<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">Name</label>
        <input type="text" id="name" class="form-value"  v-model="recipient.name"/>
      </div>
      <div class="err" id="name-err">
        <p style="color: red;">Name shouldn't contain numbers, or being empty!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Last Name</label>
        <input type="text" id="last" class="form-value" v-model="recipient.lastName"/>
      </div>
      <div class="err" id="last-err">
        <p style="color: red;">Last name shouldn't contain numbers
          or being empty!
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">E-mail</label>
        <input type="email" id="email" class="form-value" v-model="recipient.email"/>
      </div>
      <div class="err" id="email-err">
        <p style="color: red;">Email error or email is empty!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Phone</label>
        <input type="tel" id="phone" class="form-value" v-model="recipient.phone"/>
      </div>
      <div class="err" id="phone-err">
        <p style="color: red;">Phone error or empty!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Street</label>
        <input type="text" id="street" class="form-value" v-model="recipient.street"/>
      </div>
      <div class="err" id="street-err">
        <p style="color: red;">Street shouldn't be empty!
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">Zip Code</label>
        <select class="form-value" id="zip" v-model="recipient.zipCodeId">
          <option selected>---------</option>
          <option v-for="zipCode in zipCodes" :key="zipCode.id" :item="zipCode"
          :value="zipCode.id">
            {{zipCode.zipCode}}, {{zipCode.city}}
          </option>
        </select>
      </div>
      <div class="err" id="zip-err">
        <p style="color: red;">Please slect one!</p>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('Recipient'); this.object = {}" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('Recipients')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Recipient',
  props: {
    object: Number,
  },
  data() {
    return {
      zipCodes: [],
      recipient: {},
    };
  },
  mounted() {
    this.getZip();
    this.get();
  },
  methods: {
    getZip() {
      axios.get('http://localhost:4000/api/zipCodes').then(
        (result) => {
          this.zipCodes = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    get() {
      if (this.object > 0) {
        axios.get(`http://localhost:4000/api/recipients/${this.object}`).then(
          (result) => {
            this.recipient = result.data;
          },
        ).catch((error) => {
          console.log(error);
        });
      }
    },
    validateRecipient(obj) {
      const reg = /.*\d.*/;
      const reg2 = /[A-z]|[0-9]|\.|_|%|\+|-+@[A-z]|[0-9]|\.|-+\.[A-Z]{2,}/;
      const reg3 = /[+]*[(]{0,1}[0-9]{1,4}[)]{0,1}[-|\s|.|0-9]*/;
      if (obj.name && obj.lastName && obj.email
        && obj.phone && obj.street && obj.zipCodeId
        && !reg.test(obj.name) && !reg.test(obj.lastName)
        && reg2.test(obj.email) && reg3.test(obj.phone)) {
        return true;
      }
      if (!obj.name || reg.test(obj.name)) {
        document.getElementById('name').style.borderColor = 'red';
        document.getElementById('name-err').style.display = 'block';
      }
      if (!obj.lastName || reg.test(obj.lastName)) {
        document.getElementById('last').style.borderColor = 'red';
        document.getElementById('last-err').style.display = 'block';
      }
      if (!obj.email || !reg2.test(obj.email)) {
        document.getElementById('email').style.borderColor = 'red';
        document.getElementById('email-err').style.display = 'block';
      }
      if (!obj.phone || !reg3.test(obj.phone)) {
        document.getElementById('phone').style.borderColor = 'red';
        document.getElementById('phone-err').style.display = 'block';
      }
      if (!obj.street) {
        document.getElementById('street').style.borderColor = 'red';
        document.getElementById('street-err').style.display = 'block';
      }
      if (!obj.zipCodeId) {
        document.getElementById('zip').style.borderColor = 'red';
        document.getElementById('zip-err').style.display = 'block';
      }

      return false;
    },
    submit(component) {
      if (this.object === 0) {
        if (this.validateRecipient(this.recipient)) {
          axios.post('http://localhost:4000/api/recipients', {
            name: this.recipient.name,
            lastName: this.recipient.lastName,
            email: this.recipient.email,
            phone: this.recipient.phone,
            zipCodeId: this.recipient.zipCodeId,
            street: this.recipient.street,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
          this.nullify();
          this.$emit('change-component', component);
        }
      } else if (this.validateRecipient(this.recipient)) {
        axios.patch(`http://localhost:4000/api/recipients/${this.object}`, {
          name: this.recipient.name,
          lastName: this.recipient.lastName,
          email: this.recipient.email,
          phone: this.recipient.phone,
          zipCodeId: this.recipient.zipCodeId,
          street: this.recipient.street,
        })
          .then((response) => { console.log(response); alert('succesfully saved!'); })
          .catch((e) => {
            console.log(e);
          });
        this.$emit('change-component', component);
        this.$emit('object', 0);
      }
    },
    nullify() {
      document.getElementById('name').value = '';
      document.getElementById('last').value = '';
      document.getElementById('email').value = '';
      document.getElementById('phone').value = '';
      document.getElementById('street').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
